# nng_cv_until(3supp) Manual Page

## NAME

nng_cv_until - wait for condition or timeout

## SYNOPSIS

    #include <nng/nng.h>

    int nng_cv_until(nng_cv *cv, nng_time when);

## DESCRIPTION

The `nng_cv_until()` waits until either the condition variable cv is signaled by another thread calling either `nng_cv_wake()` or `nng_cv_wake1()`, or the system clock (as tracked by `nng_clock()`) reaches when.

The caller must have have ownership of the mutex that was used when cv was allocated. This function will drop the ownership of that mutex, and reacquire it atomically just before returning to the caller. (The waiting is done without holding the mutex.)

| Any condition may be used or checked, but the condition must be checked, as it is possible for this function to wake up spuriously. The best way to do this is inside a loop that repeats until the condition tests for true.

## EXAMPLE

The following example demonstrates use of this function:

Example 1: Waiting for the condition

        expire = nng_clock() + 1000; // 1 second in the future
        nng_mtx_lock(m);  // assume cv was allocated using m
        while (!condition_true) {
            if (nng_cv_until(cv, expire) == NNG_ETIMEDOUT) {
                printf("Time out reached!\n");
                break;
            }
        }
        // condition_true is true
        nng_mtx_unlock(m);

Example 2: Signaling the condition

        nng_mtx_lock(m);
        condition_true = true;
        nng_cv_wake(cv);
        nng_mtx_unlock(m);

## RETURN VALUES

None.

## ERRORS

None.

## SEE ALSO

nng_cv_alloc(3supp), nng_cv_wait(3supp), nng_cv_wake(3supp), nng_cv_wake1(3supp), nng_mtx_alloc(3supp), nng_mtx_lock(3supp), nng_mtx_unlock(3supp), nng(7)